#ifndef _NT_ISTAT_H_
#define _NT_ISTAT_H_

#include "nt_abi.h"
#include "nt_object.h"
#include "nt_file.h"

/* ntapi_tt_istat info flag bits */
#define NT_ISTAT_DEFAULT	0x00000000
#define NT_ISTAT_COMMON		0x00000001
#define NT_ISTAT_DEV_NAME_COPY	0x00000002
#define NT_ISTAT_DEV_NAME_ONLY	0x08000000
#define NT_ISTAT_MUP_DEVICE	0x20000000

typedef struct _nt_istat {
	void *		hfile;
	nt_fii		fii;
	nt_ftagi	ftagi;
	uint32_t	flags;
	uint16_t	obj_name_strlen;
	uint16_t	obj_name_maxlen;
	uint16_t	dev_name_strlen;
	uint16_t	dev_name_maxlen;
	uint32_t	dev_name_hash;
	wchar16_t	dev_name[];
} nt_istat;


typedef int32_t __stdcall ntapi_tt_istat(
	__in	void *			hfile,
	__out	nt_istat *		info,
	__in	uint32_t		infolen,
	__out	uintptr_t *		buffer,
	__in	uint32_t		buffer_size,
	__in	uint32_t		flags);

#endif
